"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
/**
 *
 * @param corPID 公司的id
 * @param corSecret 你的应用的id
 * @param agentid 你的应用的id
 */
var WechatWorkBase = /** @class */ (function () {
    function WechatWorkBase(corPID, corSecret, agentid) {
        this.accessToken = '';
        this.accessTokenExpireAt = 0;
        this.agentid = 0;
        this.accessTokenURL = 'https://qyapi.weixin.qq.com/cgi-bin/gettoken';
        this.messageSendURL = 'https://qyapi.weixin.qq.com/cgi-bin/message/send';
        this.isUpdating = false;
        this.corPID = corPID;
        this.corSecret = corSecret;
        this.agentid = agentid;
        this.axios = axios_1.default;
    }
    /**
     * 获取token并且会存储缓存
     */
    WechatWorkBase.prototype.GetAccessToken = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentDate, params, _a, errcode, access_token, expires_in, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        currentDate = +new Date();
                        if (!(this.accessTokenExpireAt < currentDate || this.isUpdating === false)) return [3 /*break*/, 4];
                        // 正在处于刷新 防止单个实例并发
                        this.isUpdating = true;
                        params = { corpid: this.corPID, corpsecret: this.corSecret };
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.axios.get(this.accessTokenURL, { params: params })];
                    case 2:
                        _a = (_b.sent()).data, errcode = _a.errcode, access_token = _a.access_token, expires_in = _a.expires_in;
                        if (errcode === 0) {
                            this.accessToken = access_token;
                            this.accessTokenExpireAt = currentDate + expires_in * 1000 - 20000;
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        console.log(error_1);
                        return [3 /*break*/, 4];
                    case 4:
                        // 解除更新状态
                        this.isUpdating = false;
                        return [2 /*return*/, this.accessToken];
                }
            });
        });
    };
    return WechatWorkBase;
}());
exports.WechatWorkBase = WechatWorkBase;
