"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var WechatWorkPush = /** @class */ (function (_super) {
    __extends(WechatWorkPush, _super);
    function WechatWorkPush() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * 最简单版本的发送消息 什么都不管你 自己玩
     *
     * @param data {MessageBody} 发送主体
     */
    WechatWorkPush.prototype.PushMessage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var token, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.GetAccessToken()];
                    case 1:
                        token = _a.sent();
                        return [4 /*yield*/, this.axios.post(this.messageSendURL + "?access_token=" + token, data)];
                    case 2:
                        res = (_a.sent()).data;
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送文本消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.text.content
     * 消息内容，最长不超过2048个字节，超过将截断
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageText = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, text, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, text = data.text;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'text',
                                text: text
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送Markdown文本消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.text.content
     * 消息内容，最长不超过2048个字节，超过将截断
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageMarkdown = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, markdown, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, markdown = data.markdown;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'markdown',
                                markdown: markdown
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送图片消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.image.media_id
     * 媒体文件id，可以调用上传临时素材接口获取
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageImage = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, image, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, image = data.image;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'image',
                                image: image
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送语音消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.voice.media_id
     * 媒体文件id，可以调用上传临时素材接口获取
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageVoice = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, image, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, image = data.image;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'voice',
                                image: image
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送视频消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.video.media_id
     * 媒体文件id，可以调用上传临时素材接口获取
     *
     * @param {string} [param0.video.title]
     * 消息标题
     *
     * @param {string} [param0.video.description]
     * 消息描述
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageVideo = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, video, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, video = data.video;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'video',
                                video: video
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送视频消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.file.media_id
     * 媒体文件id，可以调用上传临时素材接口获取
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageFile = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, file, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, file = data.file;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'file',
                                file: file
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送文本卡片消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} param0.textcard.title
     * 消息标题
     *
     * @param {string} param0.textcard.description
     * 消息描述
     *
     * @param {string} param0.textcard.url
     * 消息跳转地址
     *
     * @param {string} [param0.textcard.btntxt="详情"]
     * 消息跳转地址文本描述
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageTextcard = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, textcard, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, textcard = data.textcard;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'textcard',
                                textcard: textcard
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送图文消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {Object} param0.news
     * 图文消息new属性
     *
     * @param {Array} param0.news.articles
     * 图文列表
     *
     * @param {string} param0.news.articles.title
     * 图文列表元素标题
     *
     * @param {string} [param0.news.articles.description]
     * 图文列表元素描述
     *
     * @param {string} param0.news.articles.url
     * 图文列表元素点击后跳转的链接。
     *
     * @param {string} [param0.news.articles.picurl]
     * 图文列表元素图片链接。
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageNews = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, news, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, news = data.news;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'news',
                                news: news
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送资源存储于企业微信的图文消息
     *
     * @param {object} param0 touser toparty totag 不传值默认发送给所有人
     *
     * @param {string} [param0.touser='@all'] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {Object} param0.mpnews
     * 图文消息new属性
     *
     * @param {Array} param0.mpnews.articles
     * 图文列表
     *
     * @param {string} param0.mpnews.articles.title
     * 图文列表元素标题
     *
     * @param {string} param0.mpnews.articles.thumb_media_id
     * 图文列表元素缩略图id
     *
     * @param {string} param0.mpnews.articles.content
     * 图文列表元素内容
     *
     * @param {string} [param0.mpnews.articles.digest]
     * 图文列表元素描述
     *
     * @param {string} [param0.mpnews.articles.author]
     * 图文列表元素作者
     *
     * @param {string} [param0.mpnews.articles.content_source_url]
     * 图文列表元素点击后跳转的链接。
     *
     * @param {number} param0.safe
     * 表示是否是保密消息，0表示否，1表示是，默认0
     */
    WechatWorkPush.prototype.PushMessageMPnews = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, _d, safe, mpnews, res;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, _d = data.safe, safe = _d === void 0 ? 0 : _d, mpnews = data.mpnews;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                safe: safe,
                                agentid: this.agentid,
                                msgtype: 'mpnews',
                                mpnews: mpnews
                            })];
                    case 1:
                        res = _e.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    /**
     * 发送小程序推送消息 / 只能小程序类型的推送 不支持全员推送
     *
     * @param {object} param0 touser toparty totag
     *
     * @param {string} [param0.touser] - 成员ID列表（消息接收者，多个接收者用‘|’分隔，最多支持1000个）。特殊情况：指定为 "@all"，则向关注该企业应用的全部成员发送
     *
     * @param {string} [param0.toparty]
     * 部门ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {string} [param0.totag]
     * 标签ID列表，多个接收者用‘|’分隔，最多支持100个。当touser为 "@all" 时忽略本参数
     *
     * @param {Object} param0.miniprogram_notice
     * 小程序消息
     *
     * @param {string} param0.miniprogram_notice.title
     * 消息标题
     *
     * @param {string} param0.miniprogram_notice.appid
     * 小程序id
     *
     * @param {string} [param0.miniprogram_notice.page]
     * 点击消息卡片后的小程序页面，仅限本小程序内的页面。该字段不填则消息点击后不跳转。
     *
     * @param {string} [param0.miniprogram_notice.description]
     * 消息描述
     *
     * @param {Boolean} [param0.miniprogram_notice.emphasis_first_item]
     * 是否放大第一个
     *
     * @param {Array} [param0.miniprogram_notice.content_item]
     * 消息键值对列表 [{"key":"value"}]
     *
     */
    WechatWorkPush.prototype.PushMessageMiniProgram = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, touser, _b, toparty, _c, totag, miniprogram_notice, res;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = data.touser, touser = _a === void 0 ? '@all' : _a, _b = data.toparty, toparty = _b === void 0 ? '' : _b, _c = data.totag, totag = _c === void 0 ? '' : _c, miniprogram_notice = data.miniprogram_notice;
                        return [4 /*yield*/, this.PushMessage({
                                touser: touser,
                                toparty: toparty,
                                totag: totag,
                                msgtype: 'miniprogram_notice',
                                miniprogram_notice: miniprogram_notice
                            })];
                    case 1:
                        res = _d.sent();
                        return [2 /*return*/, res];
                }
            });
        });
    };
    return WechatWorkPush;
}(base_1.WechatWorkBase));
exports.default = WechatWorkPush;
